/**
 *
 *
 * @author Josh Lobe
 * http://ultimatetinymcepro.com
 
 * CodeMagic is a replacement source code editor plugin for Tinymce which integrates the CodeMirror (http://www.codemirror.net/) library for syntax highlighting.  
 * Adapted to eXeLearning by Ignacio Gros (http://gros.es/)
 * Compare this file with plugin.js to see what's different (we use eXe's _ function to translate the strings, etc.).
 */
 
jQuery(document).ready(function($) {

	tinymce.PluginManager.add('codemagic', function(editor, url) {
		
		// This could be in langs/all.js
		// For that, you'll have to add this line before tinymce.PluginManager.add...:
		// tinymce.PluginManager.requireLangPack('codemagic');
		tinymce.addI18n('all', {
			'Edit source code': _('Edit source code'),
			'Wrap text': _('Wrap text'),
			'Auto completion': _('Auto close tags'),
			'Highlight Code': _('Highlight syntax'),
			'Undo': _('Undo'),
			'Redo': _('Redo'),
			'Search and Replace': _('Search and Replace'),
			'Search': _('Search'),
			'Replace': _('Replace'),
			'Cancel': _('Cancel'),
			'Insert and Close': _('Update'),
			'Reformat': _('Reformat'),
			'Format HTML Code': _('Format HTML Code'),
            'Full Screen': _('Full Screen')
		});
		
		editor.addButton('codemagic', {
			image: url + '/images/html.png',
			tooltip: _('Edit source code') + " ("+_('advanced editor')+")",
			onclick: open_codemagic
		});	
		
		editor.addMenuItem('codemagic', {
			// icon: 'code',
			text: _('Edit source code') + " ("+_('advanced editor')+")",
			onclick: open_codemagic,
			context: 'tools'
		});
		
		function open_codemagic() {
			codemagicDialog = editor.windowManager.open({
				title: _('Edit source code'),
				width: 900,
				height: 650,
                maximizable: true,
				url: url+'/codemagic.htm'
			});
		}
		
	});
});